/* zf12c.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__12 = 12;

/* Subroutine */ int zf12c_c(C_fp f, integer *k, integer *ng, integer *n,
        real *eps, integer *ndig, complex *croot, integer *iter,
        integer *itmax, integer *ierr)
{
    /* Initialized data */

    static real rzero = 0.f;
    static real rten = 10.f;
    static real rhun = 100.f;
    static real rp01 = .01f;
    static real ax = .1f;
    static integer ickmax = 3;

    /* Format strings */
    static char fmt_4[] = "";
    static char fmt_5[] = "";
    static char fmt_6[] = "";
    static char fmt_9[] = "";

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7;

    /* Builtin functions */
    double pow_ri(real *, integer *), c_abs(complex *);
    void c_div(complex *, complex *, complex *), c_sqrt(complex *, complex *);

    /* Local variables */
    static integer nsig, knpn;
    static complex fprt, four, zero, d__, h__;
    static integer i__, l, knpng;
    extern /* Subroutine */ int utzf10_c(integer *, integer *);
    static complex p1;
    static real r1;
    static complex t1, t2, t3, x0, y0, z0, z1, z2, y1, y2, p5, dd, bi;
    static integer ic, jk, kn, nn;
    static complex xl, rt;
    static real qz;
    static complex xx;
    static integer nguess, lm1, ick;
    static complex den, one, tem, frt;
    static real eps1;
    static integer knp1;

    /* Assigned format variables */
    static char *nn_fmt;

    /* Parameter adjustments */
    --iter;
    --croot;

    /* Function Body */
    zero.r = 0.f, zero.i = 0.f;
    p1.r = .1f, p1.i = 0.f;
    one.r = 1.f, one.i = 0.f;
    four.r = 4.f, four.i = 0.f;
    p5.r = .5f, p5.i = 0.f;
    nsig = *ndig;
    kn = *k;
    nguess = *ng;
    *ierr = 0;
    if (*n < 1) {
        goto L19;
    }
    if (*ndig == 0 && *eps == 0.f) {
        nsig = 5;
    }
    i__1 = -nsig;
    eps1 = (real)pow_ri(&rten, &i__1);
    eps1 = min(eps1,rp01);
    knp1 = kn + 1;
    knpn = kn + *n;
    knpng = kn + nguess;
    r1 = eps1;
    if (eps1 <= 1e-5f) {
        r1 = 1e-5f;
    }
    i__1 = knpn;
    for (i__ = 1; i__ <= i__1; ++i__) {
        iter[i__] = 0;
        if (i__ > knpng) {
            i__2 = i__;
            croot[i__2].r = zero.r, croot[i__2].i = zero.i;
        }
/* L1: */
    }
    l = knp1;
L2:
    jk = 0;
    ick = 0;
    i__1 = l;
    xl.r = croot[i__1].r, xl.i = croot[i__1].i;
L3:
    ic = 0;
    h__.r = ax, h__.i = 0.f;
    q__1.r = p1.r * h__.r - p1.i * h__.i, q__1.i = p1.r * h__.i + p1.i * 
            h__.r;
    h__.r = q__1.r, h__.i = q__1.i;
    if ((real)c_abs(&xl) > ax) {
        q__1.r = p1.r * xl.r - p1.i * xl.i, q__1.i = p1.r * xl.i + p1.i * 
                xl.r;
        h__.r = q__1.r, h__.i = q__1.i;
    }
    q__1.r = xl.r + h__.r, q__1.i = xl.i + h__.i;
    rt.r = q__1.r, rt.i = q__1.i;
    nn = 0;
    nn_fmt = fmt_4;
    goto L11;
L4:
    z0.r = fprt.r, z0.i = fprt.i;
    y0.r = frt.r, y0.i = frt.i;
    x0.r = rt.r, x0.i = rt.i;
    q__1.r = xl.r - h__.r, q__1.i = xl.i - h__.i;
    rt.r = q__1.r, rt.i = q__1.i;
    nn = 1;
    nn_fmt = fmt_5;
    goto L11;
L5:
    z1.r = fprt.r, z1.i = fprt.i;
    y1.r = frt.r, y1.i = frt.i;
    q__1.r = xl.r - rt.r, q__1.i = xl.i - rt.i;
    h__.r = q__1.r, h__.i = q__1.i;
    q__2.r = rt.r - x0.r, q__2.i = rt.i - x0.i;
    c_div(&q__1, &h__, &q__2);
    d__.r = q__1.r, d__.i = q__1.i;
    rt.r = xl.r, rt.i = xl.i;
    nn = 2;
    nn_fmt = fmt_6;
    goto L11;
L6:
    z2.r = fprt.r, z2.i = fprt.i;
    y2.r = frt.r, y2.i = frt.i;
L7:
    q__1.r = one.r + d__.r, q__1.i = one.i + d__.i;
    dd.r = q__1.r, dd.i = q__1.i;
    q__2.r = z0.r * d__.r - z0.i * d__.i, q__2.i = z0.r * d__.i + z0.i * 
            d__.r;
    q__1.r = q__2.r * d__.r - q__2.i * d__.i, q__1.i = q__2.r * d__.i + 
            q__2.i * d__.r;
    t1.r = q__1.r, t1.i = q__1.i;
    q__2.r = z1.r * dd.r - z1.i * dd.i, q__2.i = z1.r * dd.i + z1.i * dd.r;
    q__1.r = q__2.r * dd.r - q__2.i * dd.i, q__1.i = q__2.r * dd.i + q__2.i * 
            dd.r;
    t2.r = q__1.r, t2.i = q__1.i;
    q__1.r = z2.r * dd.r - z2.i * dd.i, q__1.i = z2.r * dd.i + z2.i * dd.r;
    xx.r = q__1.r, xx.i = q__1.i;
    q__1.r = z2.r * d__.r - z2.i * d__.i, q__1.i = z2.r * d__.i + z2.i * 
            d__.r;
    t3.r = q__1.r, t3.i = q__1.i;
    q__3.r = t1.r - t2.r, q__3.i = t1.i - t2.i;
    q__2.r = q__3.r + xx.r, q__2.i = q__3.i + xx.i;
    q__1.r = q__2.r + t3.r, q__1.i = q__2.i + t3.i;
    bi.r = q__1.r, bi.i = q__1.i;
    q__2.r = bi.r * bi.r - bi.i * bi.i, q__2.i = bi.r * bi.i + bi.i * bi.r;
    q__5.r = xx.r * t1.r - xx.i * t1.i, q__5.i = xx.r * t1.i + xx.i * t1.r;
    q__7.r = t2.r - xx.r, q__7.i = t2.i - xx.i;
    q__6.r = t3.r * q__7.r - t3.i * q__7.i, q__6.i = t3.r * q__7.i + t3.i * 
            q__7.r;
    q__4.r = q__5.r - q__6.r, q__4.i = q__5.i - q__6.i;
    q__3.r = four.r * q__4.r - four.i * q__4.i, q__3.i = four.r * q__4.i + 
            four.i * q__4.r;
    q__1.r = q__2.r - q__3.r, q__1.i = q__2.i - q__3.i;
    den.r = q__1.r, den.i = q__1.i;
    c_sqrt(&q__1, &den);
    t1.r = q__1.r, t1.i = q__1.i;
/* Computing MAX */
    r__1 = (real)c_abs(&bi), r__2 = (real)c_abs(&t1);
    qz = rhun * max(r__1,r__2);
    q__1.r = bi.r + t1.r, q__1.i = bi.i + t1.i;
    t2.r = q__1.r, t2.i = q__1.i;
    if ((real)c_abs(&t2) + qz == qz) {
        t2.r = zero.r, t2.i = zero.i;
    }
    q__1.r = bi.r - t1.r, q__1.i = bi.i - t1.i;
    t3.r = q__1.r, t3.i = q__1.i;
    if ((real)c_abs(&t3) + qz == qz) {
        t3.r = zero.r, t3.i = zero.i;
    }
    den.r = t2.r, den.i = t2.i;
    qz = (real)c_abs(&t3) - (real)c_abs(&t2);
    if (qz > rzero) {
        den.r = t3.r, den.i = t3.i;
    }
    nn = 2;
    if ((real)c_abs(&den) == rzero) {
        goto L14;
    }
    q__2.r = -xx.r, q__2.i = -xx.i;
    c_div(&q__1, &q__2, &den);
    d__.r = q__1.r, d__.i = q__1.i;
    q__1.r = d__.r + d__.r, q__1.i = d__.i + d__.i;
    d__.r = q__1.r, d__.i = q__1.i;
    q__1.r = d__.r * h__.r - d__.i * h__.i, q__1.i = d__.r * h__.i + d__.i * 
            h__.r;
    h__.r = q__1.r, h__.i = q__1.i;
    q__1.r = rt.r + h__.r, q__1.i = rt.i + h__.i;
    rt.r = q__1.r, rt.i = q__1.i;
    if (nsig == 0) {
        goto L8;
    }
/* Computing MAX */
    r__1 = (real)c_abs(&rt);
    if ((real)c_abs(&h__) <= eps1 * max(r__1,ax)) {
        goto L16;
    }
    if (ic != 0) {
        goto L3;
    }
L8:
    nn = 3;
    nn_fmt = fmt_9;
    goto L11;
L9:
    qz = (real)c_abs(&fprt) - (real)c_abs(&z2) * rten;
    if (qz >= rzero) {
        goto L10;
    }
    z0.r = z1.r, z0.i = z1.i;
    z1.r = z2.r, z1.i = z2.i;
    z2.r = fprt.r, z2.i = fprt.i;
    y0.r = y1.r, y0.i = y1.i;
    y1.r = y2.r, y1.i = y2.i;
    y2.r = frt.r, y2.i = frt.i;
    goto L7;
L10:
    q__1.r = d__.r * p5.r - d__.i * p5.i, q__1.i = d__.r * p5.i + d__.i * 
            p5.r;
    d__.r = q__1.r, d__.i = q__1.i;
    q__1.r = h__.r * p5.r - h__.i * p5.i, q__1.i = h__.r * p5.i + h__.i * 
            p5.r;
    h__.r = q__1.r, h__.i = q__1.i;
    q__1.r = rt.r - h__.r, q__1.i = rt.i - h__.i;
    rt.r = q__1.r, rt.i = q__1.i;
L11:
    ++jk;
    if (jk > *itmax) {
        goto L17;
    }
    (*f)(&q__1, &rt);
    frt.r = q__1.r, frt.i = q__1.i;
    fprt.r = frt.r, fprt.i = frt.i;
    if (l == 1) {
        goto L15;
    }
    lm1 = l - 1;
    i__1 = lm1;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i__2 = i__;
        q__1.r = rt.r - croot[i__2].r, q__1.i = rt.i - croot[i__2].i;
        tem.r = q__1.r, tem.i = q__1.i;
        if ((real)c_abs(&tem) < 1e-4f) {
            goto L14;
        }
/* L12: */
        c_div(&q__1, &fprt, &tem);
        fprt.r = q__1.r, fprt.i = q__1.i;
    }
L13:
    if ((real)c_abs(&fprt) <= abs(*eps) && (real)c_abs(&frt) <= abs(*eps)) {
        goto L18;
    }
    switch (nn) {
        case 0: goto L4;
        case 1: goto L5;
        case 2: goto L6;
        case 3: goto L9;
    }
L14:
    if (ic != 0) {
        goto L3;
    }
    r__1 = rten * r1;
    tem.r = r__1, tem.i = 0.f;
    if ((real)c_abs(&rt) > ax) {
        q__1.r = tem.r * rt.r - tem.i * rt.i, q__1.i = tem.r * rt.i + tem.i * 
                rt.r;
        tem.r = q__1.r, tem.i = q__1.i;
    }
    q__1.r = rt.r + tem.r, q__1.i = rt.i + tem.i;
    rt.r = q__1.r, rt.i = q__1.i;
    q__3.r = h__.r + tem.r, q__3.i = h__.i + tem.i;
    q__2.r = q__3.r * d__.r - q__3.i * d__.i, q__2.i = q__3.r * d__.i + 
            q__3.i * d__.r;
    c_div(&q__1, &q__2, &h__);
    d__.r = q__1.r, d__.i = q__1.i;
    q__1.r = h__.r + tem.r, q__1.i = h__.i + tem.i;
    h__.r = q__1.r, h__.i = q__1.i;
    goto L11;
L15:
    if ((real)c_abs(&rt) < 1e-4f) {
        goto L14;
    }
    c_div(&q__1, &fprt, &rt);
    fprt.r = q__1.r, fprt.i = q__1.i;
    goto L13;
L16:
    if (ic != 0) {
        goto L18;
    }
    ic = 1;
    z0.r = y1.r, z0.i = y1.i;
    z1.r = y2.r, z1.i = y2.i;
    (*f)(&q__1, &rt);
    z2.r = q__1.r, z2.i = q__1.i;
    xl.r = rt.r, xl.i = rt.i;
    ++ick;
    if (ick <= ickmax) {
        goto L7;
    }
    jk = *itmax + jk;
L17:
    *ierr = 1;
L18:
    i__1 = l;
    croot[i__1].r = rt.r, croot[i__1].i = rt.i;
    iter[l] = jk;
    ++l;
    if (l <= knpn) {
        goto L2;
    }
    if (*ierr == 0) {
        goto L19;
    }
    utzf10_c(ierr, &c__12);
L19:
    return 0;
} /* zf12c_c */
